//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3AA3A2FF036A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3AA3A2FF036A.cm

//## begin module%3AA3A2FF036A.cp preserve=no
//## end module%3AA3A2FF036A.cp

//## Module: SPI_Response%3AA3A2FF036A; Package specification
//## Subsystem: Integral%3A9FF698031B
//## Source file: /local/data/xerxes1/gordon/cpp/xspec_cxx/Integral/SPI_Response.h

#ifndef SPI_RESPONSE_H
#define SPI_RESPONSE_H 1

//## begin module%3AA3A2FF036A.additionalIncludes preserve=no
//## end module%3AA3A2FF036A.additionalIncludes

//## begin module%3AA3A2FF036A.includes preserve=yes
//## end module%3AA3A2FF036A.includes

// xsTypes
#include "xsTypes.h"
// MultiResponse
#include "XSModel/Data/Detector/MultiResponse.h"
// OGIP-92aIO
#include "XSModel/DataFactory/OGIP-92aIO.h"
//## begin module%3AA3A2FF036A.declarations preserve=no
//## end module%3AA3A2FF036A.declarations

//## begin module%3AA3A2FF036A.additionalDeclarations preserve=yes
//## end module%3AA3A2FF036A.additionalDeclarations


//## begin SPI_Response%3AA3A5CE03C8.preface preserve=yes
//## end SPI_Response%3AA3A5CE03C8.preface

//## Class: SPI_Response%3AA3A5CE03C8
//## Category: Integral%3A9FFB9C0025
//## Subsystem: Integral%3A9FF698031B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class SPI_Response : public MultiResponse, //## Inherits: <unnamed>%3AA3A60E00B0
                     	public OGIP_92aIO  //## Inherits: <unnamed>%3AA7EE1F0290
{
  //## begin SPI_Response%3AA3A5CE03C8.initialDeclarations preserve=yes
  //## end SPI_Response%3AA3A5CE03C8.initialDeclarations

  public:
    //## Constructors (generated)
      SPI_Response();

      SPI_Response(const SPI_Response &right);

    //## Destructor (generated)
      virtual ~SPI_Response();


    //## Other Operations (specified)
      //## Operation: read%3AA7EE5F02D7
      virtual size_t read (const string& fileName, bool readFlag = true);

      //## Operation: clone%3AA7EE8500EC
      virtual SPI_Response* clone () const;

      //## Operation: fileFormat%3AA7EE78031E
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: closeSourceFiles%3AA7EE8E002C
      virtual void closeSourceFiles (size_t index = 0);

      //## Operation: readAuxResponse%3AA7EEBA0167
      virtual bool readAuxResponse ();

    //## Get and Set Operations for Associations (generated)

      //## Association: Integral::<unnamed>%3DE3C05102E6
      //## Role: SPI_Response::efficiency%3DE3C052023A
      virtual const RealArray& efficiency () const;

    // Additional Public Declarations
      //## begin SPI_Response%3AA3A5CE03C8.public preserve=yes
      //## end SPI_Response%3AA3A5CE03C8.public

  protected:

    //## Other Operations (specified)
      //## Operation: setArrays%3ACA2BA3022F
      virtual void setArrays ();

      //## Operation: setDescription%3ACA2BA701F6
      virtual void setDescription (size_t specNum = 1, size_t groupNum = 1);

      //## Operation: Swap%3AA7EEF70323
      //## Exceptions: ()
      virtual void Swap (MultiResponse& right) throw ();

    // Additional Protected Declarations
      //## begin SPI_Response%3AA3A5CE03C8.protected preserve=yes
      //## end SPI_Response%3AA3A5CE03C8.protected

  private:
    //## Assignment Operation (generated)
      SPI_Response & operator=(const SPI_Response &right);


    //## Other Operations (specified)
      //## Operation: groupEbounds%3AA7EEE801B3
      void groupEbounds ();

      //## Operation: copy%3AA7EEFF0170;  C++
      virtual void copy (const MultiResponse& right);

    // Additional Private Declarations
      //## begin SPI_Response%3AA3A5CE03C8.private preserve=yes
      //## end SPI_Response%3AA3A5CE03C8.private

  private: //## implementation
    // Data Members for Associations

      //## Association: Integral::<unnamed>%3DE3C05102E6
      //## begin SPI_Response::efficiency%3DE3C052023A.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_efficiency;
      //## end SPI_Response::efficiency%3DE3C052023A.role

    // Additional Implementation Declarations
      //## begin SPI_Response%3AA3A5CE03C8.implementation preserve=yes
      //## end SPI_Response%3AA3A5CE03C8.implementation

};

//## begin SPI_Response%3AA3A5CE03C8.postscript preserve=yes
//## end SPI_Response%3AA3A5CE03C8.postscript

// Class SPI_Response 

//## Get and Set Operations for Associations (inline)

inline const RealArray& SPI_Response::efficiency () const
{
  //## begin SPI_Response::efficiency%3DE3C052023A.get preserve=no
  return m_efficiency;
  //## end SPI_Response::efficiency%3DE3C052023A.get
}

//## begin module%3AA3A2FF036A.epilog preserve=yes
//## end module%3AA3A2FF036A.epilog


#endif
